#include "stdafx.h"
#include "MfcStlTest.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include <iostream>
#include <algorithm>
#include "mfcstl_array_veneer.h"



CWinApp theApp;

void PrintOut(const DWORD& dw)
{
    std::cout << dw << "  ";
}

int _tmain(void)
{
	int nRetCode = 0;

	// Init MFC
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		_tprintf(_T("MFC Init failed!\n"));
		nRetCode = 1;
	}
	else
	{
        using std::cout;
        using std::endl;
        using mfcstl::array_veneer;
        using std::sort;
        using std::for_each;
        using std::copy;
        using std::back_inserter;

        // Test 1: array_veneer and std::sort
        array_veneer<CDWordArray> av1;
        av1.push_back(3);
        av1.push_back(1);
        av1.push_back(7);
        av1.push_back(4);
        av1.push_back(2);

        cout << "Unsorted array: ";
        for_each(av1.begin(), av1.end(), PrintOut);
        cout << endl;

        sort(av1.begin(), av1.end());
        cout << "Sorted array:   ";
        std::for_each(av1.begin(), av1.end(), PrintOut);
        cout << endl << endl;

        // Test 2: array_veneer and std::back_inserter;
        array_veneer<CDWordArray> av2;
        copy(av1.begin(), av1.end(), back_inserter(av2));
        cout << "Copied array:   ";
        for_each(av2.begin(), av2.end(), PrintOut);
	}

	return nRetCode;
}
